function [theta, phi] = blochAngles(psi)
%[theta, phi] = blochAngles(psi)
%   calculates the Euler angles 
%   |psi> =  cos(theta/2)|0>+exp(i*phi)*sin(theta/2)|1>

% 28-03-2010  hannes@majer.ch

phi = angle(psi);
phi = phi(1,:)-phi(2,:);
phi = phi -floor(phi/(2*pi))*2*pi;

theta = 2*acos(abs(psi(1,:)));
