function draw3DArrow(arrow, color, origin)
%draw3DArrow(arrow, color, origin)

% 23-03-2010  hannes@majer.ch

a = 0.15;   % relative length of the arrow head
b = 0.075;  % reltaive diameter of the arrow head
N = 16;     % number of polygons

if nargin<3
    origin = [0 0 0];
end
if nargin<2
    color = 'r';
end

length = norm(arrow);

if length > 0 
	hold on
    % Draw arrow
    vector = [0 arrow(1);0 arrow(2); 0 arrow(3)];
    vector(1,:) = vector(1,:)+origin(1);
    vector(2,:) = vector(2,:)+origin(2);
    vector(3,:) = vector(3,:)+origin(3);
	h=plot3(vector(2,:), -vector(1,:), vector(3,:), color);
	set(h,'LineWidth',2)	

    % Draw arrow head
    e1=cross(arrow/length,[0 1 0]);
 	if norm(e1)==0 
 		e1=[1 0 0];
 	else
 		e1=e1/norm(e1);
    end  
 	e2=cross(arrow/length,e1);
 	e2=e2/norm(e2);
    phi = 0:2*pi/N:2*pi;
    re=-a*arrow'*ones(1,N+1)+b*(e1'*cos(phi)+e2'*sin(phi));
    x(1,:) = zeros(1,N);
    x(2,:) = re(1,1:N);
    x(3,:) = re(1,2:N+1);
    y(1,:) = zeros(1,N);
    y(2,:) = re(2,1:N);
    y(3,:) = re(2,2:N+1);
    z(1,:) = zeros(1,N);
    z(2,:) = re(3,1:N);
    z(3,:) = re(3,2:N+1);
    x = x+vector(1,2);
    y = y+vector(2,2);
    z = z+vector(3,2);
    c = ones(size(x));
    fill3(y, -x, z, 'r')
    
    hold off
end
