function drawBlochSphere(center, radius, color)
%drawBlochSphere(center, radius, color)

% 23-03-2010  hannes@majer.ch

if nargin<3
    color = 'k';
end
if nargin<2
    radius = 1;
end
if nargin<1
    center = [0 0 0];
end

theta=0:0.01:2*pi;

hold on

plot3(cos(theta)*radius+center(1),sin(theta)*radius+center(2),zeros(size(theta))+center(3),color)
plot3(cos(theta)*radius+center(1),zeros(size(theta))+center(2),sin(theta)*radius+center(3),color)
plot3(zeros(size(theta))+center(1),cos(theta)*radius+center(2),sin(theta)*radius+center(3),color)

plot3([-1 1]*radius+center(1),[0 0]+center(2),[0 0]+center(3),color)
plot3([0 0]+center(1),[-1 1]*radius+center(2),[0 0]+center(3),color)
plot3([0 0]+center(1),[0 0]+center(2),[-1 1]*radius+center(3),color)

hold off

axis equal